/*
 *  CAUCarbonViewNib.h
 *  CAUCarbonViewNib
 
 *
 *  Created by Airy Andr on Sun Oct 06 2002.
 *  Copyright (c) 2002 __MyCompanyName__. All rights reserved.
 *
 */
#ifndef __AUCARBONVIEWNIB_H__
#define __AUCARBONVIEWNIB_H__

// Plugin views are based on this class
#include "AUCarbonViewBase.h"

// -----------------------------------------------------------------------------
// Class CAUStkView
//
// This class implements a GUI pane initialized from a nib file.
// -----------------------------------------------------------------------------
class CAUCarbonViewNib: public AUCarbonViewBase
{
public:
    // Construction ------------------------------
    CAUCarbonViewNib(AudioUnitCarbonView inInstance);	// ID of the carbon view to create
    ~CAUCarbonViewNib();

    // Configuration Methods -----------------------
    virtual CFStringRef GetBundleID() = 0; // Return the bundle ID of the component
    virtual CFStringRef GetWindowNibName() { return CFSTR("window"); }
    virtual CFStringRef GetWindowCompositingName() { return CFSTR("windowCompositing"); }
    virtual CFStringRef GetWindowNoCompositingName() { return CFSTR("window"); }
    
    virtual bool HasBackgroundPict() { return true; }
    virtual CFStringRef GetBackgroundFilename() { return CFSTR("AUBackground.png"); }

    // Do we patch QD to make background works with all controls (for non compositing windows)
    virtual bool PatchEraseRect() { return true; }
    
    // Baseclass overrides -----------------------
    OSStatus CreateUI(Float32, 		// x position within parent window
		      Float32);		// y position within parent window

    // New Methods -----------------------
    virtual void InitWindow(CFBundleRef sBundle); // Register custom controls...
    virtual void FinishWindow(CFBundleRef sBundle); // Called after window creation

    // Used by QD patch for controls to have the window background (for non compositing windows)
    virtual CGImageRef GetBackgroundImage() { return mBackgroundImage; }
    virtual void GetPaneBounds(Rect *rect);

protected:
    CQDProcs mProcs;
    CQDProcs* mCurrentProcsPtr;
    CGImageRef mBackgroundImage;
};
#endif
// -----------------------------------------------------------------------------
// End of file.
// -----------------------------------------------------------------------------
