/*
 *  TImageCache.cpp
 *  NeuSynth
 *
 *  Created by Airy Andr on Sun Nov 24 2002.
 *  Copyright (c) 2002 __MyCompanyName__. All rights reserved.
 *
 */

#include "TImageCache.h"

CFMutableDictionaryRef TImageCache::mImageCache = 0;

CGImageRef TImageCache::GetImage(CFURLRef url)
{
    CGImageRef image = 0;

    if (mImageCache == 0) {
	mImageCache = CFDictionaryCreateMutable(NULL, 0, &kCFTypeDictionaryKeyCallBacks, &kCFTypeDictionaryValueCallBacks);
    }
    if (CFDictionaryGetValueIfPresent(mImageCache, url, &image)) {
	if (image) CFRetain(image);
    } else  {
	CGDataProviderRef provider = CGDataProviderCreateWithURL( url );
	if (provider) {
	    image = CGImageCreateWithPNGDataProvider( provider, NULL, false,  kCGRenderingIntentDefault );
	    CGDataProviderRelease( provider );
	}
	if (image)
	    CFDictionaryAddValue(mImageCache, url, image);
    }
    return image;
}

void TImageCache::Reset()
{
    if (mImageCache) {
	CFRelease(mImageCache);
	mImageCache = 0;
    }
}
